"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var graphql_relay_1 = require("graphql-relay");
var path_1 = require("path");
var Dataloader = require('dataloader');
var globby = require('globby');
var FileSystem = (function () {
    function FileSystem() {
        this.statsLoader = new Dataloader(batchedStat);
    }
    FileSystem.prototype.getStats = function (path) {
        return this.statsLoader.load(path);
    };
    FileSystem.prototype.search = function (path, name, offset, limit) {
        return __awaiter(this, void 0, void 0, function () {
            var files;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, globby([path + "**"])];
                    case 1:
                        files = _a.sent();
                        return [2 /*return*/, files
                                .filter(function (file) { return file.includes(name); })
                                .sort(function (a, b) { return a.split(path_1.sep).length - b.split(path_1.sep).length; })
                                .slice(offset, offset + limit)
                                .map(function (file) { return ({
                                id: graphql_relay_1.toGlobalId('File', file),
                                path: file
                            }); })];
                }
            });
        });
    };
    FileSystem.prototype.list = function (path, offset, limit) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var files, entries;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, globby([path + "*"])];
                    case 1:
                        files = _a.sent();
                        return [4 /*yield*/, Promise.all(files.map(function (file) { return __awaiter(_this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _a = { file: file };
                                        return [4 /*yield*/, this.getStats(file)];
                                    case 1: return [2 /*return*/, (_a.stats = _b.sent(), _a)];
                                }
                            }); }); }))];
                    case 2:
                        entries = _a.sent();
                        return [2 /*return*/, entries
                                .slice(offset, offset + limit)
                                .map(function (entry) { return ({
                                id: graphql_relay_1.toGlobalId('Directory', entry.file),
                                path: entry.file,
                                isDirectory: entry.stats.isDirectory()
                            }); })];
                }
            });
        });
    };
    return FileSystem;
}());
exports.FileSystem = FileSystem;
function batchedStat(paths) {
    return Promise.all(paths.map(function (path) { return new Promise(function (resolve, reject) { return fs_1.stat(path, function (err, stats) {
        if (err) {
            return reject(err);
        }
        resolve(stats);
    }); }); }));
}
