"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var express = require("express");
var graphqlHTTP = require("express-graphql");
var schema_1 = require("./schema");
var FileSystem_1 = require("./FileSystem");
function startServer(port) {
    var app = express();
    app.use('/', express.static('.'));
    app.use('/graphql', graphqlHTTP(function (req) { return ({
        schema: schema_1.schema,
        context: {
            req: req,
            fs: new FileSystem_1.FileSystem()
        },
        formatError: function (error) { return ({
            message: error.message,
            locations: error.locations,
            stack: error.stack
        }); },
        graphiql: true
    }); }));
    app.listen(port, function () {
        console.log("Listen on http://localhost:" + port + "/graphql");
    });
}
exports.startServer = startServer;
